%define	major	5.1
%define	libname %mklibname lua %{major}
%define alt_priority %(echo %{major} | sed -e 's/[^0-9]//g')

Summary:	Powerful, light-weight programming language
Name:		lua5.1
Version:	5.1.5
Release:	%mkrel 4
License:	MIT
URL:		http://www.lua.org/
Group:		Development/Other
Source0:	http://www.lua.org/ftp/lua-%{version}.tar.gz
Patch0:		lua-5.1-dynlib.patch
Patch1:		lua-5.1-pkgconfig_libdir.patch
Patch2:		lua-5.1-modules_path.patch
BuildRequires:  readline-devel
Conflicts:	lua < 5.1.4-11
# Provides:	lua = %{version}-%{release}

%description
Lua is a programming language originally designed for extending applications, 
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data 
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in 
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

%package -n	%{libname}
Summary:	Powerful, light-weight programming language
Group:		System/Libraries

%description -n	%{libname}
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package includes the libraries.


%package -n	%{libname}-devel
Summary:	Powerful, light-weight programming language
Group:		Development/Other
Requires:	%{libname} = %{version}
# to have the same provides on all arches
Provides:	lua%{major}-devel = %{version}-%{release}
# conflict with other versions
Conflicts:	lua-devel

%description -n	%{libname}-devel
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package contains the headers and development files for lua.


%package -n	%{libname}-devel-static
Summary:	Powerful, light-weight programming language
Group:		Development/Other
Requires:	%{libname}-devel = %{version}
# to have the same provides on all arches
Provides:	lua%{major}-devel-static = %{version}-%{release}
# conflict with other versions
Conflicts:	lua-devel-static

%description -n	%{libname}-devel-static
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package contains the headers and development files for lua.


%prep
%setup -q -n lua-%{version}

%patch0 -p1 -b .dynlib
%patch1 -p1 -b .pkgconfig
%patch2 -p1 -b .modules

sed -i -e "s|/usr/local|%{_prefix}|g" Makefile
sed -i -e "s|/lib|/%{_lib}|g" Makefile
sed -i -e "s|/usr/local|%{_prefix}|g" src/luaconf.h
sed -i -e "s|/lib|/%{_lib}|g" src/luaconf.h
sed -i -e "s|/man/man1|/share/man/man1|g" Makefile
sed -i -e "s|\$(V)|%{major}|g" src/Makefile

%build
sed -i 's/-lncurses/-lncursesw/g' */Makefile*
%make linux CFLAGS="%{optflags} -fPIC -DLUA_USE_LINUX"
sed -i -e "s#/usr/local#%{_prefix}#" etc/lua.pc
sed -i -e 's/-lreadline -lncurses //g' etc/lua.pc

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std INSTALL_TOP=%{buildroot}%{_prefix} INSTALL_LIB=%{buildroot}%{_libdir} INSTALL_MAN=%{buildroot}%{_mandir}/man1
install -d %{buildroot}%{_libdir}/lua/%{major}/
install -d %{buildroot}%{_datadir}/lua/%{major}/
install -m 644 test/*.lua %{buildroot}%{_datadir}/lua/%{major}/

install -m 755 src/liblua.so.%{major}* %{buildroot}%{_libdir}
ln -s liblua.so.%{major} %{buildroot}%{_libdir}/liblua.so

install -d -m 755 %{buildroot}%{_libdir}/pkgconfig/
install -m 644 etc/lua.pc %{buildroot}%{_libdir}/pkgconfig/

# for update-alternatives
mv %{buildroot}%{_bindir}/lua %{buildroot}%{_bindir}/lua%{major}
mv %{buildroot}%{_bindir}/luac %{buildroot}%{_bindir}/luac%{major}

# to avoid conflict with other versions
mv %{buildroot}/%{_mandir}/man1/lua.1 %{buildroot}/%{_mandir}/man1/lua%{major}.1
mv %{buildroot}/%{_mandir}/man1/luac.1 %{buildroot}/%{_mandir}/man1/luac%{major}.1

%clean
rm -rf $RPM_BUILD_ROOT


%post
/usr/sbin/update-alternatives --install %{_bindir}/lua lua %{_bindir}/lua%{major} %{alt_priority} --slave %{_bindir}/luac luac %{_bindir}/luac%{major}

%postun
[[ -f %_bindir/lua%{major} ]] || /usr/sbin/update-alternatives --remove lua %{_bindir}/lua%{major}

%files
%defattr (-,root,root)
%doc COPYRIGHT HISTORY INSTALL README
%doc doc/*.html doc/*.gif
%{_bindir}/*
%dir %{_libdir}/lua
%{_libdir}/lua/%{major}
%{_datadir}/lua/%{major}/*.lua
%{_mandir}/man1/*

%files -n %{libname}
%defattr (-,root,root)
%{_libdir}/*.so.*

%files -n %{libname}-devel
%defattr (-,root,root)
%{_includedir}/*
%{_libdir}/pkgconfig/*
%{_libdir}/*.so

%files -n %{libname}-devel-static
%defattr (-,root,root)
%{_libdir}/*.a







%changelog
* Sat Oct 19 2013 umeabot <umeabot> 5.1.5-4.mga4
+ Revision: 530734
- Mageia 4 Mass Rebuild

  + luigiwalser <luigiwalser>
    - fix conflict with lua on upgrade from mga2 (mga#10222)

* Sun Jul 28 2013 wally <wally> 5.1.5-3.mga4
+ Revision: 459456
- drop .a files from devel pkg (they're already in static one)

* Sat Jan 12 2013 umeabot <umeabot> 5.1.5-2.mga3
+ Revision: 359074
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Jun 08 2012 fwang <fwang> 5.1.5-1.mga3
+ Revision: 257689
- new version 5.1.5

* Wed Jun 06 2012 tv <tv> 5.1.4-12.mga3
+ Revision: 256631
- imported package lua5.1


* Wed Jun 06 2012 Thierry Vignaud <tvignaud@mandriva.com> 5.1.4-12.mga3
- initial release, forked from lua-5.1.14-11.mga2
